Listing 6: test.pas

program test;
uses
  Objects;
var
  Coll : TCollection;
  s1, s2, s3 : string;

procedure GlobalEach (Which : Pointer); far;
var
  APointer : pointer;
begin
  asm
    mov  ax, [bp + 8];
    mov  WORD PTR APointer, ax;
    mov  ax, [bp + 10];
    mov  WORD PTR APointer + 2, ax;
  end;
  writeln (string (APointer^));
  asm
    mov  sp, bp;
    pop  bp;
    retf 6;
  end;
end; { GlobalEach }

function GlobalFirst (Which : Pointer) : Boolean; far;
var
  APointer : pointer;
begin
  asm
    mov  ax, [bp + 8];
    mov  WORD PTR APointer, ax;
    mov  ax, [bp + 10];
    mov  WORD PTR APointer + 2, ax;
  end;
  GlobalFirst := (string (APointer^) [1] = 'S');
  asm
    mov  sp, bp;
    pop  bp;
    retf 6;
  end;
end; { GlobalFirst }

procedure TryProcs;

  procedure LocalEach (Which : Pointer); far;
  begin
    writeln (string (Which^));
  end; { LocalEach }

  function LocalFirst (Which : Pointer) : Boolean; far;
  begin
    LocalFirst := (string (Which^) [1] = 'S');
  end; { LocalFirst }

begin
  Coll.Init (10, 10);
  s1 := 'First string';
  s2 := 'Second string';
  s3 := 'Third string';
  Coll.Insert (@s1);
  Coll.Insert (@s2);
  Coll.Insert (@s3);
  writeln ('*** Calling ForEach with a local iterator ***');
  Coll.ForEach (@LocalEach);
  writeln ('*** Calling ForEach with a global iterator ***');
  Coll.ForEach (@GlobalEach);
  writeln ('*** Calling FirstThat with a local iterator ***');
  writeln (string (Coll.FirstThat (@LocalFirst)^));
  writeln ('*** Calling FirstThat with a global iterator ***');
  writeln (string (Coll.FirstThat (@GlobalFirst)^));
  writeln ('*** Success! ***');
  Coll.DeleteAll;
  Coll.Done;
end; { TryProcs }

begin
  TryProcs;
end.
